<?php

if(!defined("OVS"))
    die("Direct access to this file is prohibited due to security reasons.");

// SECURITY TUNING: Don't accept iframes to this website
header('X-Frame-Options: DENY');

function getUserIP() {
    
    if (isset($_SERVER["HTTP_CF_CONNECTING_IP"])) {
              $_SERVER['REMOTE_ADDR'] = $_SERVER["HTTP_CF_CONNECTING_IP"];
              $_SERVER['HTTP_CLIENT_IP'] = $_SERVER["HTTP_CF_CONNECTING_IP"];
    }
    $client  = @$_SERVER['HTTP_CLIENT_IP'];
    //$forward = @$_SERVER['HTTP_X_FORWARDED_FOR']; Security vulnerabilty!
    $remote  = $_SERVER['REMOTE_ADDR'];
    $forward = $remote;

    if(filter_var($client, FILTER_VALIDATE_IP))
    {
        $ip = $client;
    }
    elseif(filter_var($forward, FILTER_VALIDATE_IP))
    {
        $ip = $forward;
    }
    else
    {
        $ip = $remote;
    }
    
    return $ip;
}

function send_http_request($url, $payload, $method, $timeout) {
	
	if($method == 'post') {
		
		$post = true;
	}else{
		
		$post = false;
	}
	
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_USERAGENT, 'Online Voting System - Yeditepe University Student Project');
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_POST, $post);
	
	if(!empty($payload)):
		
		curl_setopt($ch, CURLOPT_POSTFIELDS, @http_build_query($payload));
	endif;
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
	curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
	
	if(curl_errno($ch) == 0) {
		
		$ch_res = curl_exec($ch);
		curl_close($ch);
		return $ch_res;
		
	}else{
		
		curl_close($ch);
		return false;
	}
}

// $info is a array with the structure of ["name" => (name of person), "surname" => (surname of person), "by" => (birth year), "ni" => (turkish citizenship national identification number)]
function nviapi($info) {
    
    if(!is_array($info)) {
        
        return [false, "You need to input a array!"];
    }
    
    if(!isset($info['name']) || !isset($info['surname']) || !isset($info['by']) || !isset($info['ni'])) {
        
        return [false, "Invalid input!"];
    }
    
    if(strlen($info['ni']) < 11 || strlen($info['ni']) > 11) {
        
        return [false, "Invalid national identifier number!"];
    }
    
    $ni = $info['ni'];
    $name = $info['name'];
    $surname = $info['surname'];
    $by = $info['by'];
    
    // SOAP Envelope initialization for NVI XMLRPC API National Identifier validation
$envelope = "<?xml version=\"1.0\" encoding=\"utf-8\"?>
<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">
  <soap:Body>
    <TCKimlikNoDogrula xmlns=\"http://tckimlik.nvi.gov.tr/WS\">
      <TCKimlikNo>$ni</TCKimlikNo>
      <Ad>$name</Ad>
      <Soyad>$surname</Soyad>
      <DogumYili>$by</DogumYili>
    </TCKimlikNoDogrula>
  </soap:Body>
</soap:Envelope>";
    
    $ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, "https://tckimlik.nvi.gov.tr/Service/KPSPublic.asmx");
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_HEADER, false);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $envelope);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array(
		'POST /Service/KPSPublic.asmx HTTP/1.1',
		'Host: tckimlik.nvi.gov.tr',
		'Content-Type: text/xml; charset=utf-8',
		'SOAPAction: "http://tckimlik.nvi.gov.tr/WS/TCKimlikNoDogrula"',
		'Content-Length: ' . strlen($envelope)
	));
	$ret = curl_exec($ch);
	curl_close($ch);
	
	$ret = strip_tags($ret);
	if($ret == 'true') {
	    
	    return [$ret, ""];
	}else{
	    
	    return [false, "Your personal information is wrong!"];
	}
}